<template>
  <div class="mt-2 lg:mt-8 pb-1 lg:pb-3 text-center">
    <h1>ATK Reporting</h1>
    <p>Please report your ATK result below</p>
  </div>

  <div class="grid formgrid p-fluid w-full lg:w-8 m-auto">
    <div class="field mb-4 col-12">
      <label for="name" class="font-medium text-900">Name</label>
      <InputText id="name" type="text" v-model="name" readonly :disabled="true" />
    </div>

    <div class="field mb-4 col-12 md:col-6">
      <label for="studentId" class="font-medium text-900">Student ID</label>
      <InputText id="studentId" type="text" v-model="studentId" readonly :disabled="true" />
    </div>

    <div class="field mb-4 col-12 md:col-6">
      <label for="inspectionDate" class="font-medium text-900">Date of inspection</label>
      <Calendar id="inspectionDate" :showIcon="true" v-model="dateOfInspection" />
    </div>

    <div class="mb-4 col-12">
      <div class="font-medium text-900">ATK Result</div>
      <div class="flex gap-3">
        <div
          class="inline-flex align-items-center justify-content-center px-3 py-2 text-900 text-lg cursor-pointer border-round border-1 surface-border transition-colors transition-duration-150"
          @click="result = false"
          :class="{
            'surface-card surface-border hover:surface-hover': result !== false,
            'bg-green-500 text-white border-primary': result === false,
          }"
        >
          Negative
        </div>
        <div
          class="inline-flex align-items-center justify-content-center px-3 py-2 text-900 text-lg cursor-pointer border-round border-1 surface-border transition-colors transition-duration-150"
          @click="result = true"
          :class="{
            'surface-card surface-border hover:surface-hover': result !== true,
            'bg-red-500 text-white border-primary': result === true,
          }"
        >
          Positive
        </div>
      </div>
    </div>

    <div class="field mb-4 col-12 md:col-6">
      <label for="resultImage" class="font-medium text-900">Upload results photo</label>
      <FileUpload
        id="resultImage"
        mode="basic"
        name="avatar"
        accept="image/*"
        :maxFileSize="1000000"
        class="p-button-outlined p-button-plain"
        chooseLabel="Choose file"
        @upload="handleFileUpload"
      />
    </div>

    <div class="col-12">
      <Button label="Submit" class="w-auto border-round-lg mt-3 px-8" @click="submitResults"></Button>
    </div>
  </div>
</template>

<script setup>
import { ref, computed, onMounted } from 'vue';
import { format } from 'date-fns';
import { useResultsStore } from '@/stores/resultsStore';
import { useUserStore } from '@/stores/userStore';

const resultsStore = useResultsStore();
const userStore = useUserStore();

const name = ref('');
const studentId = ref('');
const dateOfInspection = ref(new Date());
const result = ref(null);
const resultImage = ref(null);

const handleFileUpload = (files) => {
  resultImage.value = files; // assuming the event returns the files array directly
};

// Initialize fields with user data
onMounted(() => {
  if (userStore.userData) {
    name.value = userStore.userData.user.name;
    studentId.value = userStore.userData.user.studentId;
  }
});

// const allFieldsFilled = computed(() => {
//   return (
//     name.value.trim() !== '' &&
//     studentId.value.trim() !== '' &&
//     dateOfInspection.value instanceof Date &&
//     result.value !== null &&
//     resultImage.value &&
//     resultImage.value.length > 0
//   );
// });

const submitResults = async () => {
  // if (!allFieldsFilled.value) {
  //   alert('Please fill in all fields.');
  //   return;
  // }

  const formattedDate = format(dateOfInspection.value, 'yyyy-MM-dd');
  const resultData = {
    userId: userStore.userData.user.id,
    date: formattedDate,
    result: result.value,
  };

  try {
    await resultsStore.uploadResult(resultData);
    alert('Result uploaded successfully!');
  } catch (error) {
    console.error('Error uploading results:', error);
    alert('Failed to upload results');
  }
};
</script>
